%define module	setuptools

#  WARNING  When bootstrapping, disable tests as well,
#           because tests need pip.
%bcond_without bootstrap

# Disabled for now as pytest-fixture-config is requires which is imcompatible with pytest >= 4.0.0
%bcond_with tests

%if %{without bootstrap}
%global python_wheelname %{module}-%{version}-py3-none-any.whl
%global python3_record %{python3_sitelib}/%{module}-%{version}.dist-info/RECORD
%endif
%global python_wheeldir %{_datadir}/python-wheels

Summary:	Easily build and distribute Python packages
Name:		python-%{module}
Version:	63.4.3
Release:	%mkrel 1
License:	MIT
Group:		Development/Python
Url:		https://pypi.python.org/pypi/setuptools
Source0:	https://files.pythonhosted.org/packages/source/s/%{module}/%{module}-%{version}.tar.xz
Patch0:     setuptools-link-C-modules-with-libpython.patch

%description
A collection of enhancements to the Python distutils that allow
you to more easily build and distribute Python packages, especially
ones that have dependencies on other packages.

%package -n python3-%{module}
Summary:	Easily build and distribute Python3 packages
Group:		Development/Python

BuildRequires:	pkgconfig(python3)
%if %{with tests}
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(mock)
%endif
%if %{without bootstrap}
BuildRequires:  python3-pip
%endif
Provides:   python3dist(setuptools)
Requires:	python3-pkg-resources

Provides:	python3-setuptools-devel = %{version}-%{release}
Obsoletes:	python3-setuptools-devel

Provides:	python3-distribute = %{version}-%{release}
Obsoletes:	python3-distribute 

Conflicts:      python2-setuptools < %{version}-%{release}

%{?python_provide:%python_provide python3-%{module}}

%description -n python3-%{module}
A collection of enhancements to the Python 3 distutils that allow
you to more easily build and distribute Python 3 packages, especially
ones that have dependencies on other packages.

%package -n python3-pkg-resources
Summary: Runtime module to access python 3 resources
Group:		Development/Python
Obsoletes:	python3-pkg-resources
Provides:	python3-pkg-resources = %{version}-%{release}

%description -n python3-pkg-resources
Module used to find and manage Python 3 package/version dependencies and access
bundled files and resources, including those inside of zipped .egg files.

%package wheel
Summary:	The setuptools wheel

%description wheel
A Python wheel of setuptools to use with venv.

%prep
%setup -q -n %{module}-%{version}
%apply_patches

%if %{without bootstrap}
# If we don't have setuptools installed yet, we use the pre-generated .egg-info
rm -r %{module}.egg-info
%endif

# Strip shbang
find setuptools pkg_resources -name \*.py | xargs sed -i -e '1 {/^#!\//d}'

# Remove bundled exes
rm -f setuptools/*.exe

# remove tests that can't be run on the BS
rm setuptools/tests/test_integration.py
rm setuptools/tests/test_sdist.py
rm setuptools/tests/test_easy_install.py

%build
%if %{without bootstrap}
%py3_build
%else
%pyproject_wheel
%endif

%install
%if %{without bootstrap}
%py3_install
%else
%pyproject_install
%endif

rm -rf %{buildroot}%{python3_sitelib}/setuptools/tests

%if %{without bootstrap}
sed -i '/^setuptools\/tests\//d' %{buildroot}%{python3_record}
%endif

find %{buildroot}%{python3_sitelib} -name '*.exe' | xargs rm -f

# Don't ship these
rm -r docs/conf.py

%files -n python3-setuptools
%doc LICENSE
%doc docs/* CHANGES.rst README.rst
%{python3_sitelib}/setuptools*
%{python3_sitelib}/_distutils_hack/
%{python3_sitelib}/distutils-precedence.pth


%files -n python3-pkg-resources
%{python3_sitelib}/pkg_resources/

%if %{without bootstrap}
%files wheel
%doc LICENSE
# we own the dir for simplicity
%dir %{python_wheeldir}/
%{python_wheeldir}/%{python_wheelname}
%endif

%changelog
* Thu Aug 11 2022 TerryN <terryn94 at gmail.com> 63.4.3-1pclos2022
- update
- switch to pyproject build
- link C modules with libpython

* Wed Feb 09 2022 TerryN <terryn94 at gmail.com> - 59.8.0-1pclos2022
- update

* Wed Feb 19 2020 onkelho <oh.quait at gmail.com> - 45.2.0-1pclos2020
- new ver-rel

* Sat Apr 20 2019 tex 41.0.0-2pclos2019
- fix spec
